      SUBROUTINE GAMI(GI,A,X)
C
C Subroutine for the calculation of the incomplete gamma function.
C
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
C Check if X is negative or A is not positive.
      IF(X.LT.0.D0.OR.A.LE.0.D0) GO TO 10
C If X is less than A+1, use series calculation,
C otherwise use continued fraction expansion.
      IF(X.LT.A+1.D0) CALL SEGAMI(GI,A,X)
      IF(X.GE.A+1.D0) CALL CFGAMI(GI,A,X) 
      GO TO 11
 10   PAUSE 'X is negative or A is not positive.'
 11   CONTINUE
      RETURN
      END
